Readings

Snapshot, Historical or Feeds reading data

Overview

Samsara allows you to retrieve and ingest time-series readings for assets and sensors in your organization using the Readings API. Readings provide a unified interface for accessing diagnostic data, environmental sensor data, trailer telemetry, tire conditions, and more. See Reading Categories for a full catalog of available readings.

Before you run the cURL examples on this page, store your API token in the SAMSARA_API_TOKEN environment variable and reference that variable in the Authorization header.

There are four endpoints that allow you to interact with readings data:

EndpointDescription
/readings/definitionsDiscover available readings, their data types, units, and metadata.
/readings/latestGet a "snapshot" of the last known reading values.
/readings/historyPull a historical report or feed of reading values over time.
/readingsIngest new readings for API-created assets.

Entity Types

Readings are associated with an entity type. You must specify the entityType query parameter on every request (except /readings/definitions, where the optional entityTypes parameter filters the results). The following entity types are supported:

Entity TypeDescription
assetVehicles, powered equipment, unpowered equipment, and other tracked assets.
sensorEnvironmental monitors, cargo sensors, door monitors, and level monitors.

Definitions

The GET /readings/definitions endpoint is an introspection endpoint for discovering the set of readings including their name, description, data type, unit, and other metadata.

Use this endpoint to:

  • Enumerate all available reading IDs before querying for data
  • Discover the data type and enum values for a reading
  • Check whether a reading supports ingestion via the API (look at the ingestionEnabled field on each definition)
curl --request GET 'https://api.samsara.com/readings/definitions' \
--header "Authorization: Bearer $SAMSARA_API_TOKEN" \
-G
{
    "data": [
        {
            "readingId": "engineRpm",
            "entityType": "asset",
            "label": "Engine Speed",
            "description": "Represents the engine speed in revolutions per minute (RPM).",
            "category": "diagnostic",
            "type": {
                "dataType": "integer",
                "unit": {
                    "measurementType": "rotationalSpeed",
                    "baseUnit": "rpm"
                }
            },
            "enumValues": null,
            "ingestionEnabled": true
        },
        {
            "readingId": "engineState",
            "entityType": "asset",
            "label": "Engine State",
            "description": "Indicates the current state of the engine, such as running, stopped.",
            "category": "diagnostic",
            "type": {
                "dataType": "integer"
            },
            "enumValues": [
                { "symbol": "off", "label": "Off" },
                { "symbol": "running", "label": "Running" },
                { "symbol": "idling", "label": "Idling" }
            ],
            "ingestionEnabled": true
        }
    ],
    "pagination": {
        "endCursor": "...",
        "hasNextPage": false
    }
}

Query Parameters

ParameterRequiredDescription
idsNoComma-separated list of reading IDs. Up to 50. If not set, all readings returned.
entityTypesNoComma-separated list of entity types to filter by (e.g. asset, sensor).
afterNoPagination cursor from a previous response.

Snapshot

The GET /readings/latest endpoint returns the last known reading values for a set of entities at the specified time.

This endpoint is suited for use cases where you need a point-in-time view of asset or sensor state rather than a continuous data stream. For example, you can use this endpoint to:

  • Get the current engine speed, fuel level, and coolant temperature for all vehicles
  • Get the last known reading values as of a specific point in time
  • Periodically refresh known asset state at a frequency that matches your use case
curl --request GET 'https://api.samsara.com/readings/latest' \
-d readingIds='engineRpm,fuelLevelPerc,coolantTemp' \
-d entityType='asset' \
--header "Authorization: Bearer $SAMSARA_API_TOKEN" \
-G
{
    "data": [
        {
            "readingId": "engineRpm",
            "entityId": "123456",
            "value": 3000,
            "happenedAtTime": "2024-01-27T07:06:25Z"
        },
        {
            "readingId": "fuelLevelPerc",
            "entityId": "123456",
            "value": 72.5,
            "happenedAtTime": "2024-01-27T07:05:10Z"
        }
    ],
    "pagination": {
        "endCursor": "...",
        "hasNextPage": false
    }
}

Query Parameters

ParameterRequiredDescription
readingIdsYesComma-separated list of reading IDs. Up to 3 per request. Use /readings/definitions to discover valid IDs.
entityTypeYesThe entity type to fetch readings for (asset or sensor).
entityIdsNoComma-separated list of entity IDs to filter by. If not set, all entities are returned.
externalIdsNoComma-separated list of external IDs to filter by (e.g. samsara.serial:ZPXKLMN7VJ).
asOfTimeNoReturns the last known values with timestamps less than or equal to this time. Defaults to now. RFC 3339 format.
includeExternalIdsNoSet to true to include external IDs in the response.
afterNoPagination cursor from a previous response.

Historical Report

The GET /readings/history endpoint returns reading values within a specified time range.

This endpoint should not be used for continuous synchronization as it is more susceptible to "missing" data due to connectivity issues. For continuous synchronization, use the Feed mode instead.

This endpoint is best suited for cases such as:

  • Back-filling historical reading data
  • Ad-hoc querying of historical data between two timestamps
  • Generating reports for a specific time window
curl --request GET 'https://api.samsara.com/readings/history' \
-d readingId='engineRpm' \
-d entityType='asset' \
-d startTime='2024-01-01T00:00:00Z' \
-d endTime='2024-01-02T00:00:00Z' \
--header "Authorization: Bearer $SAMSARA_API_TOKEN" \
-G
{
    "data": [
        {
            "entityId": "123456",
            "value": 3000,
            "happenedAtTime": "2024-01-01T08:15:30Z"
        },
        {
            "entityId": "123456",
            "value": 2800,
            "happenedAtTime": "2024-01-01T08:17:45Z"
        }
    ],
    "pagination": {
        "endCursor": "...",
        "hasNextPage": true
    }
}

Query Parameters

ParameterRequiredDescription
readingIdYesThe reading ID to retrieve data for. Use /readings/definitions to discover valid IDs.
entityTypeYesThe entity type to fetch readings for (asset or sensor).
entityIdsNoComma-separated list of entity IDs to filter by. If not set, all entities are returned.
externalIdsNoComma-separated list of external IDs to filter by.
startTimeNoStart of the time range (inclusive). RFC 3339 format.
endTimeNoEnd of the time range (exclusive). Defaults to now if not provided. RFC 3339 format.
feedNoSet to true to enable feed mode for continuous synchronization.
includeExternalIdsNoSet to true to include external IDs in the response.
afterNoPagination cursor from a previous response.

Data is returned where startTime <= happenedAtTime < endTime.

Feed

The GET /readings/history endpoint also supports a feed mode for continuously synchronizing reading data. Enable it by setting feed=true.

Feed mode should be used for synchronizing reading data over time. You repeatedly poll this endpoint, and each response provides a cursor for the next request so you receive only new data since the last call.

You can poll the endpoint every 5 seconds for near-real-time data, or every 24 hours for a daily sync. In either case, each poll returns all new reading updates since the last request.

Feed mode is better than historical report for synchronizing data because it is much less susceptible to "missing" data due to connectivity issues.

curl --request GET 'https://api.samsara.com/readings/history' \
-d readingId='engineRpm' \
-d entityType='asset' \
-d feed='true' \
--header "Authorization: Bearer $SAMSARA_API_TOKEN" \
-G
{
    "data": [
        {
            "entityId": "123456",
            "value": 3100,
            "happenedAtTime": "2024-01-27T08:00:05Z"
        }
    ],
    "pagination": {
        "endCursor": "dXNlcjpVMEc5V0ZYMnEw",
        "hasNextPage": false
    }
}

Feed Polling Workflow

  1. Make an initial request with feed=true (and optionally startTime).
  2. Process all data items in the response.
  3. Use the endCursor from pagination as the after parameter in your next request.
  4. If hasNextPage is true, immediately make the next request.
  5. If hasNextPage is false, wait at least 5 seconds before polling again to avoid unnecessary requests.
  6. Repeat from step 2.

Important: In feed mode, the response always includes an endCursor, even when hasNextPage is false. Always use this cursor for the next request to avoid re-fetching data you've already received.

Ingesting Readings

The POST /readings endpoint allows you to ingest batches of reading data points for API-created assets.

Note: Ingesting readings is only supported for assets created using the POST /assets endpoint with readingsIngestionEnabled set to true. Not all readings support ingestion — see the Ingestion Enabled column in each Reading Categories table below, or check the ingestionEnabled field returned by GET /readings/definitions.

Note on location: The location reading ID is overloaded — the read-path reading (returned by GET /readings/latest and GET /readings/history) is a String describing the asset's current address, while the ingest-path reading is a separate Object value that must contain latitude, longitude, and speed. When ingesting location data, always send the Object form shown in the example below.

curl --request POST 'https://api.samsara.com/readings' \
--header "Authorization: Bearer $SAMSARA_API_TOKEN" \
--header 'Content-Type: application/json' \
-d '{
    "data": [
        {
            "readingId": "engineRpm",
            "entityId": "123451234512345",
            "entityType": "asset",
            "happenedAtTime": "2024-10-27T10:00:00Z",
            "value": 2400
        },
        {
            "readingId": "location",
            "entityId": "123451234512345",
            "entityType": "asset",
            "happenedAtTime": "2024-10-27T10:00:00Z",
            "value": {
                "latitude": 37.7749,
                "longitude": -122.4194,
                "speed": 45.0
            }
        }
    ]
}'

Constraints

  • Up to 1000 data points per request.
  • happenedAtTime must not be older than the last known reading for the same series.
  • Only asset entity type is currently supported for ingestion.

Reading Categories

All readings are organized by category. Use the GET /readings/definitions endpoint to retrieve the authoritative, up-to-date list with full metadata. The sections below document every available reading grouped by category. The Ingestion Enabled column indicates whether a reading can be sent to the POST /readings endpoint.

Note: This is not an exhaustive list. Your organization may have access to additional readings based on enabled features or custom configurations. Use the /readings/definitions endpoint to retrieve all available reading IDs for your organization, and rely on its ingestionEnabled field as the source of truth for ingestion support.

CategoryEntity TypeDescription
diagnosticassetCore asset diagnostics: engine, fuel, GPS, temperatures, pressures, EV, electrical, and more.
obdassetAdvanced OBD data: ADAS/AEBS, cruise control, stability control.
smartTrailerasset, sensorSmart trailer telemetry, door monitors, environment sensors, and brake monitoring.
reeferassetRefrigerated trailer: zone temperatures, set points, state, fuel, alarms.
tireConditionassetPer-tire pressure and temperature across up to 3 axles.
levelMonitoringasset, sensorTank fill levels, volumes, masses, and fluid status.
pressureVesselHealthassetPressure vessel temperature, pressure, and battery level.

Diagnostic

Entity type: asset

Core asset diagnostics including engine metrics, fuel, GPS location, temperatures, pressures, electrical, EV data, and more.

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
airInletPressureAir Inlet PressureAir inlet pressure.FloatkilopascalNo
airTempAir Inlet (Ambient Air) TempAir inlet (ambient air) temperature.FloatcelsiusNo
altitudeAltitudeThe altitude of the asset.FloatmeterNo
altitudeAccuracyAltitude UncertaintyThe uncertainty of the asset's GPS-based altitude.FloatmeterNo
assetStatusStatusCombined movement and equipment status derived from location and Digio events.Enum-No
averageACCurrentAverage AC CurrentAverage AC current in amperes.FloatampereNo
averageACFrequencyAverage AC FrequencyAverage AC frequency in Hertz.FloathertzNo
averageLineToLineACRMSVoltageAverage Line-to-Line VoltageAverage RMS voltage between AC lines in volts.FloatvoltNo
averageLineToNeutralACRMSVoltageAverage Line-to-Neutral VoltageAverage RMS voltage from AC line to neutral in volts.FloatvoltNo
barometerPressureBarometric PressureAtmospheric pressure as measured by the barometer.FloatkilopascalNo
batteryPotentialSwitchedBattery Potential (Switched)Switched battery potential in volts.FloatvoltNo
batteryVoltageBattery VoltageVoltage of the asset's battery.FloatvoltYes
boostPressureEngineTurbocharger1Engine Turbocharger 1 Boost PressureRepresents the boost pressure for engine turbocharger 1.FloatkilopascalNo
boostPressurePaBoost PressureRepresents the boost pressure.FloatkilopascalNo
boostPressureTurbocharger2Boost Pressure (Turbocharger 2)Boost pressure from the second turbocharger in kPa.FloatkilopascalNo
canBusTypeCAN Bus StatusIndicates whether the CAN Bus system is active or provides an invalid reading.Enum-No
checkEngineLightJ1939EmissionsCheck Engine Light (J1939) - EmissionsIndicates whether the J1939 check engine light emissions indicator is active or inactive.Enum-No
checkEngineLightJ1939ProtectCheck Engine Light (J1939) - ProtectIndicates whether the J1939 check engine light protect indicator is active or inactive.Enum-No
checkEngineLightJ1939StopCheck Engine Light (J1939) - StopIndicates whether the J1939 check engine light stop indicator is active or inactive.Enum-No
checkEngineLightJ1939WarningCheck Engine Light (J1939) - WarningIndicates whether the J1939 check engine light warning indicator is active or inactive.Enum-No
checkEngineLightPassengerCheck Engine Light (Passenger)Indicates whether the passenger check engine light indicator is active or inactive.Enum-No
coolantTempEngine Coolant TempRepresents the engine coolant temperature.FloatcelsiusYes
crankcasePressureCrankcase PressureThe pressure inside the engine's crankcase.FloatkilopascalNo
defLevelDEF LevelRepresents the DEF (Diesel Exhaust Fluid) level percentage.FloatpercentNo
derivedFuelConsumedLifetime Fuel Consumed (Samsara)Samsara-maintained fuel consumption since the device was first installed.IntegerliterNo
digioInput1Digital IO #1Represents the state of digital IO #1.Enum-No
dpfLampStatusDPF Lamp StatusStatus of the Diesel Particulate Filter warning lamp.Enum-No
dpfSootLoadPercentDPF Soot LoadDiesel Particulate Filter soot load percentage.FloatpercentNo
ecuFuelLevelMillipercentFuel Level (ECU)Fuel level percentage reported directly by the vehicle ECU.FloatpercentYes
ecuHistoryTotalRunTimeECU Total Run TimeTotal engine run time from ECU in seconds.IntegersecondNo
engineExhaustTemperatureEngine Exhaust TemperatureTemperature of the engine exhaust.FloatcelsiusNo
engineHoursEngine Hours (ECU)Represents the total engine runtime in hours as reported by the ECU.FloatsecondYes
engineHoursDigioBasedEngine Hours (Synthetic - Aux input)Represents the synthetic total engine runtime in hours based on auxiliary input.FloatmillisecondNo
engineHoursEngineStateBasedEngine Hours (Synthetic)Represents the synthetic total engine runtime in hours based on engine state.FloatmillisecondNo
engineImmobilizerEngine ImmobilizerThe state of the engine immobilizer.Enum-No
engineIntakeAirTempEngine Intake Air TemperatureRepresents the engine intake air temperature.FloatcelsiusNo
engineLoadPercentEngine LoadEngine load percentage.FloatpercentNo
engineOilTemperatureEngine Oil TemperatureTemperature of the engine oil.FloatcelsiusNo
engineRpmEngine SpeedEngine speed in revolutions per minute (RPM).IntegerrpmYes
engineStateEngine StateIndicates the current state of the engine, such as running, stopped.Enum-Yes
engineTotalIdleTimeEngine Total Idle TimeTotal idle time for the asset.FloatminuteNo
evAverageCellTemperatureEV Average Cell TemperatureAverage temperature of EV battery cells in degrees Celsius.FloatcelsiusNo
evChargingCurrentEV Charging CurrentCharging current for electric and hybrid assets.FloatampereNo
evChargingEnergyEV Charging EnergyCharging energy for electric and hybrid assets.FloatwatthourNo
evChargingStatusEV Charging StatusCharging status for electric and hybrid assets.Enum-No
evChargingVoltageEV Charging VoltageCharging voltage for electric and hybrid assets.FloatvoltNo
evConsumedEnergyEV Consumed EnergyConsumed energy (including regenerated) for electric and hybrid assets.FloatwatthourNo
evDistanceDrivenEV Distance DrivenElectric distance driven for electric and hybrid assets.FloatmeterNo
evHighCapacityBatteryCurrentEV High Capacity Battery CurrentCurrent from the high capacity EV battery in amperes.FloatampereNo
evHighCapacityBatteryVoltageHigh Capacity EV Battery VoltageRepresents the voltage of the high capacity EV battery.FloatvoltNo
evRegeneratedEnergyEV Regenerated EnergyRegenerated energy for electric and hybrid assets.FloatwatthourNo
exhaustGasPressureExhaust Gas PressureRepresents the exhaust gas pressure.FloatkilopascalNo
faultCodesFault CodesEngine fault codes for the asset (read-only aggregated view). For ingestion, use faultCodesOBDII or faultCodesJ1939 instead.Object-No
faultCodesJ1939Fault Codes (J1939)J1939 diagnostic trouble codes with SPN/FMI and lamp status (malfunctionIndicatorLamp, redStopLamp, amberWarningLamp, protectLamp, suspectParameterNumber, failureModeIdentifier, occurrenceCount, sourceAddress).Object-Yes
faultCodesOBDIIFault Codes (OBD-II)OBD-II diagnostic trouble codes and check engine light status (diagnosticTroubleCodes: array of DTC short codes; checkEngineLightIsOn: boolean).Object-Yes
fuelConsumptionRateFuel Consumption RateThe rate at which an asset uses fuel.Floatliters/hourNo
fuelLevelPercFuel LevelPercentage of fuel remaining in the tank.FloatpercentYes
fuelSourceFuel SourceType of fuel used by the asset.Enum-No
geoCoordinatesGeo CoordinatesGPS coordinates (latitude and longitude) of the asset's location.Object-No
gpsDistanceGPS DistanceThe distance the asset has traveled since the gateway was installed based on GPS calculations.FloatmeterNo
gpsSpeedGPS SpeedAsset speed measured by the gateway's GPS receiver.Floatmeters/secNo
idlingDurationCumulative Idling DurationThe cumulative idling duration. Cumulative values always increase.FloatmillisecondNo
ignitionStatusIgnition StatusIndicates the current ignition status as a voltage.Enum-No
latitudeLatitudeLatitude coordinate of the asset's location.Floatdecimal degreesNo
lifetimeFuelConsumedLifetime Fuel ConsumedRepresents the asset's lifetime fuel consumption as reported by the asset.IntegerliterNo
locationLocationRepresents the current address of the asset.String-Yes (see Ingesting Readings for the separate ingest value shape)
longitudeLongitudeLongitude coordinate of the asset's location.Floatdecimal degreesNo
mnfldTempIntake Manifold TempRepresents the intake manifold temperature.FloatcelsiusNo
ngFuelPressureNG Fuel PressureRepresents the natural gas fuel pressure.FloatkilopascalNo
odometerEcuOdometer (ECU)Represents the total distance traveled as recorded by the ECU.FloatmeterYes
odometerGpsOdometer (GPS)Represents the total distance traveled as determined by GPS.FloatmeterNo
oilPressureEngine Oil PressureRepresents the oil pressure in the engine.FloatkilopascalYes
phaseAACFrequencyPhase A AC FrequencyAC frequency for Phase A in Hertz.FloathertzNo
phaseAAmpsRmsPhase A Current (RMS)RMS current for Phase A in amperes.FloatampereNo
phaseALLVoltsPhase A Line-to-Line VoltageLine-to-line voltage for Phase A in volts.FloatvoltNo
phaseALNVoltsPhase A Line-to-Neutral VoltageLine-to-neutral voltage for Phase A in volts.FloatvoltNo
phaseBAmpsRmsPhase B Current (RMS)RMS current for Phase B in amperes.FloatampereNo
phaseBLLVoltsPhase B Line-to-Line VoltageLine-to-line voltage for Phase B in volts.FloatvoltNo
phaseBLNVoltsPhase B Line-to-Neutral VoltageLine-to-neutral voltage for Phase B in volts.FloatvoltNo
phaseCAmpsRmsPhase C Current (RMS)RMS current for Phase C in amperes.FloatampereNo
phaseCLLVoltsPhase C Line-to-Line VoltageLine-to-line voltage for Phase C in volts.FloatvoltNo
phaseCLNVoltsPhase C Line-to-Neutral VoltageLine-to-neutral voltage for Phase C in volts.FloatvoltNo
powerFactorRatioPower Factor RatioRepresents the power factor ratio.FloatpercentNo
rfidCardIdScanRFID Card ScanThe card number from RFID Card scans used for identification. When a user taps their RFID card on the reader, this captures the unique card code.Integer-No
samsaraEngineHoursSamsara Engine HoursSamsara's intelligent engine hours calculation that combines ECU data, synthetic calculations, and manual overrides with automatic fallbacks for optimal accuracy across all asset types.FloatmillisecondNo
samsaraEngineHoursWithSourceSamsara Engine Hours with SourceSamsara's intelligent engine hours calculation including detailed source metadata to indicate the origin of the data (ECU, synthetic, or manual override).Object-No
samsaraOdometerSamsara OdometerSamsara automatically pulls odometer readings from an asset's ECU. If not available and unregulated, you can manually enter the odometer value which updates based on GPS trip data.FloatkilometerNo
samsaraSpeedSamsara SpeedSamsara's best estimate of the asset speed, combining multiple data sources such as ECU and GPS.Floatmeters/secNo
samsaraSpeedLimitSamsara Speed LimitSpeed limit at the location of the asset.Floatmeters/secNo
seatbeltDriverSeatbelt (Driver)Indicates whether the driver's seatbelt is buckled or unbuckled.Enum-No
tellTalesTell Tale StatusTell tales status as read from the asset.Object-No
tirePressuresBackLeftTire Pressure, Back LeftRepresents the tire pressure for the back-left tire.FloatkilopascalNo
tirePressuresBackRightTire Pressure, Back RightRepresents the tire pressure for the back-right tire.FloatkilopascalNo
tirePressuresFrontLeftTire Pressure, Front LeftRepresents the tire pressure for the front-left tire.FloatkilopascalNo
tirePressuresFrontRightTire Pressure, Front RightRepresents the tire pressure for the front-right tire.FloatkilopascalNo
torquePercentTorqueEngine torque as a percentage.FloatpercentNo
totalApparentPowerTotal Apparent PowerTotal apparent power in volt-amperes.Floatvolt-ampereNo
totalEnergyExportedTotal Energy ExportedRepresents the total energy exported in kilowatt-hours (kWh).Floatkilowatt-hourNo
totalReactivePowerTotal Reactive PowerTotal reactive power in volt-amperes reactive.Floatvolt-ampere reactiveNo
totalRealPowerTotal Real PowerTotal real power in watts.FloatwattNo

OBD

Entity type: asset

Advanced OBD data including ADAS/AEBS state, cruise control, and stability control readings.

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
accDistanceAlertSignalACC Distance AlertDistance Alert Signal from the Adaptive Cruise Control system.Enum-No
adaptiveCruiseControlModeACC ModeCurrent mode of the Adaptive Cruise Control System.Enum-No
aebsDriverActivationDemandAEBS ActivationWhether Advanced Emergency Braking is enabled or disabled by the driver.Enum-No
cruiseControlSetSpeedCruise Control Set SpeedDriver's set speed for the cruise control system.Floatkm/hrNo
cruiseControlSwitchCruise Control SwitchThe state of the cruise control switch.Enum-No
ecuSpeedECU SpeedSpeed read from the asset's OBD port.Floatkm/hrNo
emergencyBrakingAebsStateAEBS State (Collision)State of the Emergency Braking System for Forward Collision.Enum-No
forwardCollisionWarningLevelAEBS FCW LevelSeverity level of the AEBS Forward Collision Warning.Enum-No
forwardCollisionWarningStatusACC FCW StatusStatus of the Adaptive Cruise Control Forward Collision Warning system.Enum-No
forwardLaneImagerStatusForward Lane Imager StateState of the Forward Lane Imager.Enum-No
imminentLeftLaneDepartureImminent Left Lane DepartureState of the Imminent Left Lane Departure detection.Enum-No
imminentRightLaneDepartureImminent Right Lane DepartureState of the Imminent Right Lane Departure detection.Enum-No
laneCenteringSystemStateLane Centering StateState of the Lane Centering System.Enum-No
laneDepartureIndicationStatusLDW IndicationState of the Lane Departure Indication system.Enum-No
laneDepartureWarningSystemStateLDW System StateState of the Lane Departure Warning system.Enum-No
laneKeepingAssistSystemStateLKAS StateState of the Lane Keep Assist System.Enum-No
roadDepartureAebsStateAEBS State (Lane Departure)State of the AEBS system for Lane Departure.Enum-No
ropBrakeControlActiveROP Brake Control ActiveIndicates whether Roll Over Prevention (ROP) has activated brake control.Enum-No
ropEngineControlActiveROP Engine Control ActiveIndicates whether Roll Over Prevention (ROP) has commanded engine control to be active.Enum-No
tractionControlOverrideSwitchTraction Control Override SwitchWhen the switch is on, the automatic traction control function is disabled by the driver.Enum-No
turnSignalTurn SignalState of the turn signal switch (blinker).Enum-No
vdcFullyOperationalVDC Fully OperationalIndicates whether the Vehicle Dynamic Stability Control (VDC) system is fully operational.Enum-No
vehicleGearVehicle GearThe gear of the vehicle that is currently selected.Enum-No
xbrActiveControlModeEmergency Self-Braking System ModeCurrent mode of the emergency self-braking system.Enum-No
xbrSystemStateEmergency Self-Braking System Operational StateState of the emergency self-braking system.Enum-No
ycBrakeControlActiveYC Brake Control ActiveIndicates whether Yaw Control (YC) has activated brake control.Enum-No
ycEngineControlActiveYC Engine Control ActiveIndicates whether Yaw Control (YC) has commanded engine control to be active.Enum-No

Smart Trailer

Entity type: asset, sensor

Smart trailer telemetry, door monitors, environment sensors, and brake monitoring.

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
addressEntryAddress EntryAddress data from the address entry event.Object-No
addressExitAddress ExitAddress data from the address exit event.Object-No
ag51BatteryStatusAG51 Battery StatusBattery status of the AG51 gateway based on temperature-compensated voltage threshold.Enum-No
ag51BatteryTemperatureAG51 Battery TemperatureInternal temperature of the AG51 gateway battery in degrees Celsius.FloatcelsiusNo
ag51BatteryVoltageAG51 Battery VoltageTotal battery voltage of the AG51 gateway (sum of all 3 cells) in volts.FloatvoltNo
atisLampATIS Lamp StatusATIS lamp on/off status.Enum-No
derivedCargoStateCargo StatusIndicates if the overall cargo status of the asset is Empty, Partially Empty, Full, or Unknown.Enum-No
doorClosedStatusDoor Closed StatusStatus indicating whether a door is closed or open.Enum-No
doorClosedStatusAdvancedDoor Closed Status (Advanced)Status indicating whether a door is closed or open (advanced).Enum-No
environmentMonitorAmbientTemperatureAmbient TemperatureAir temperature at the environmental monitor device (built-in sensor).FloatcelsiusNo
environmentMonitorAmbientTemperatureBLEConnectionAmbient Temperature (BLE Connection)Air temperature at the environmental monitor device (built-in sensor) via BLE Connection.FloatcelsiusNo
environmentMonitorThermistorTemperatureThermistor TemperatureTemperature from an external thermistor probe (e.g. cable probe in cargo or reefer).FloatcelsiusNo
environmentMonitorThermistorTemperatureBLEConnectionThermistor Temperature (BLE Connection)Temperature from an external thermistor probe (e.g. cable probe in cargo or reefer) via BLE Connection.FloatcelsiusNo
trailerMovingWithoutPowerTrailer Moving Without PowerTrailer moving without power status.Enum-No
validBrakeScoreBraking Performance ValuePercent score representing trailer braking effectiveness using regression analysis over the past 90 days, guaranteed to have under 3% margin of error.FloatpercentNo
widgetBatteryVoltageWidget Battery VoltageBattery voltage level of the widget sensor in millivolts.FloatvoltNo
widgetBatteryVoltageLowWidget Battery Voltage LowIndicates if widget battery voltage is below 1500mV threshold.Enum-No
widgetDisconnectWidget Disconnection StatusConnection status between widget and device.Enum-No

Reefer

Entity type: asset

Refrigerated trailer data including zone temperatures, set points, reefer state, fuel, and alarms.

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
reeferAlarmReefer AlarmsArray of active alarm codes for the refrigeration unit with metadata.Object-No
reeferAlarmSeverityReefer Alarm SeverityHighest severity level across active reefer alarms.Enum-No
reeferAmbientAirReefer Ambient Air TemperatureExternal environment temperature for the reefer.FloatcelsiusNo
reeferBatteryVoltageReefer Battery VoltageThe voltage of the Refrigeration Unit's battery.FloatvoltNo
reeferDoorOpenZone1Reefer Door Open (Zone 1)Status indicating whether the reefer's door (zone 1) is closed or open.Enum-No
reeferDoorOpenZone2Reefer Door Open (Zone 2)Status indicating whether the reefer's door (zone 2) is closed or open.Enum-No
reeferDoorOpenZone3Reefer Door Open (Zone 3)Status indicating whether the reefer's door (zone 3) is closed or open.Enum-No
reeferEngineHoursReefer Engine HoursThe total accumulated hours that the Refrigeration Unit has been running.FloathourNo
reeferFuelLevelReefer Fuel LevelRefrigeration Unit Fuel Level (%).FloatpercentNo
reeferPowerSourceReefer Power SourceThe power source of the refrigeration unit (Diesel, Electric or Cryo).Enum-No
reeferReturnAirZone1Reefer Return Air Temperature (Zone 1)Return air temperature for the reefer's zone 1.FloatcelsiusNo
reeferReturnAirZone2Reefer Return Air Temperature (Zone 2)Return air temperature for the reefer's zone 2.FloatcelsiusNo
reeferReturnAirZone3Reefer Return Air Temperature (Zone 3)Return air temperature for the reefer's zone 3.FloatcelsiusNo
reeferRunModeReefer Run ModeThe run mode of the refrigeration unit (Continuous or Start/Stop).Enum-No
reeferSetPointZone1Reefer Set Point (Zone 1)Current set point for the reefer's zone 1.FloatcelsiusNo
reeferSetPointZone2Reefer Set Point (Zone 2)Current set point for the reefer's zone 2.FloatcelsiusNo
reeferSetPointZone3Reefer Set Point (Zone 3)Current set point for the reefer's zone 3.FloatcelsiusNo
reeferStateReefer StateThe on/off state of the refrigeration unit.Enum-No
reeferStateZone1Reefer State (Zone 1)The on/off state of the refrigeration unit (Zone 1).Enum-No
reeferStateZone2Reefer State (Zone 2)The on/off state of the refrigeration unit (Zone 2).Enum-No
reeferStateZone3Reefer State (Zone 3)The on/off state of the refrigeration unit (Zone 3).Enum-No
reeferSupplyAirZone1Reefer Supply Air Temperature (Zone 1)Supply air temperature for the reefer's zone 1.FloatcelsiusNo
reeferSupplyAirZone2Reefer Supply Air Temperature (Zone 2)Supply air temperature for the reefer's zone 2.FloatcelsiusNo
reeferSupplyAirZone3Reefer Supply Air Temperature (Zone 3)Supply air temperature for the reefer's zone 3.FloatcelsiusNo
reeferTemperatureRecorder1Reefer Temperature Recorder (Zone 1)Temperature recorder reading for reefer zone 1.FloatcelsiusNo
reeferTemperatureRecorder2Reefer Temperature Recorder (Zone 2)Temperature recorder reading for reefer zone 2.FloatcelsiusNo
reeferTemperatureRecorder3Reefer Temperature Recorder (Zone 3)Temperature recorder reading for reefer zone 3.FloatcelsiusNo
reeferTemperatureRecorder4Reefer Temperature Recorder (Zone 4)Temperature recorder reading for reefer zone 4.FloatcelsiusNo
reeferTemperatureRecorder5Reefer Temperature Recorder (Zone 5)Temperature recorder reading for reefer zone 5.FloatcelsiusNo
reeferTemperatureRecorder6Reefer Temperature Recorder (Zone 6)Temperature recorder reading for reefer zone 6.FloatcelsiusNo

Tire Condition

Entity type: asset

Per-tire pressure and temperature readings across up to 3 axles with 4 tire positions each (left outer, left inner, right inner, right outer).

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
axle1tirefromleft1pressureAxle 1 Left Outer Tire PressurePressure of the left outer tire on axle 1.FloatkilopascalNo
axle1tirefromleft1temperatureAxle 1 Left Outer Tire TemperatureTemperature of the left outer tire on axle 1.FloatcelsiusNo
axle1tirefromleft2pressureAxle 1 Left Inner Tire PressurePressure of the left inner tire on axle 1.FloatkilopascalNo
axle1tirefromleft2temperatureAxle 1 Left Inner Tire TemperatureTemperature of the left inner tire on axle 1.FloatcelsiusNo
axle1tirefromleft3pressureAxle 1 Right Inner Tire PressurePressure of the right inner tire on axle 1.FloatkilopascalNo
axle1tirefromleft3temperatureAxle 1 Right Inner Tire TemperatureTemperature of the right inner tire on axle 1.FloatcelsiusNo
axle1tirefromleft4pressureAxle 1 Right Outer Tire PressurePressure of the right outer tire on axle 1.FloatkilopascalNo
axle1tirefromleft4temperatureAxle 1 Right Outer Tire TemperatureTemperature of the right outer tire on axle 1.FloatcelsiusNo
axle2tirefromleft1pressureAxle 2 Left Outer Tire PressurePressure of the left outer tire on axle 2.FloatkilopascalNo
axle2tirefromleft1temperatureAxle 2 Left Outer Tire TemperatureTemperature of the left outer tire on axle 2.FloatcelsiusNo
axle2tirefromleft2pressureAxle 2 Left Inner Tire PressurePressure of the left inner tire on axle 2.FloatkilopascalNo
axle2tirefromleft2temperatureAxle 2 Left Inner Tire TemperatureTemperature of the left inner tire on axle 2.FloatcelsiusNo
axle2tirefromleft3pressureAxle 2 Right Inner Tire PressurePressure of the right inner tire on axle 2.FloatkilopascalNo
axle2tirefromleft3temperatureAxle 2 Right Inner Tire TemperatureTemperature of the right inner tire on axle 2.FloatcelsiusNo
axle2tirefromleft4pressureAxle 2 Right Outer Tire PressurePressure of the right outer tire on axle 2.FloatkilopascalNo
axle2tirefromleft4temperatureAxle 2 Right Outer Tire TemperatureTemperature of the right outer tire on axle 2.FloatcelsiusNo
axle3tirefromleft1pressureAxle 3 Left Outer Tire PressurePressure of the left outer tire on axle 3.FloatkilopascalNo
axle3tirefromleft1temperatureAxle 3 Left Outer Tire TemperatureTemperature of the left outer tire on axle 3.FloatcelsiusNo
axle3tirefromleft2pressureAxle 3 Left Inner Tire PressurePressure of the left inner tire on axle 3.FloatkilopascalNo
axle3tirefromleft2temperatureAxle 3 Left Inner Tire TemperatureTemperature of the left inner tire on axle 3.FloatcelsiusNo
axle3tirefromleft3pressureAxle 3 Right Inner Tire PressurePressure of the right inner tire on axle 3.FloatkilopascalNo
axle3tirefromleft3temperatureAxle 3 Right Inner Tire TemperatureTemperature of the right inner tire on axle 3.FloatcelsiusNo
axle3tirefromleft4pressureAxle 3 Right Outer Tire PressurePressure of the right outer tire on axle 3.FloatkilopascalNo
axle3tirefromleft4temperatureAxle 3 Right Outer Tire TemperatureTemperature of the right outer tire on axle 3.FloatcelsiusNo

Level Monitoring

Entity type: asset, sensor

Tank fill levels, volumes, masses, and fluid status for level monitors.

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
fillCriticalityFill Level CriticalityIndicates if the state of the fill level is critical.Enum-No
fillMassFill MassMass of material in the vessel.FloatkilogramNo
fillMassAvailableCapacityFill Mass Available CapacityAvailable mass to be filled in the vessel.FloatkilogramNo
fillPercentFill Level PercentFill level of the vessel as a percentage full.FloatpercentNo
fillVolumeFill VolumeVolume of material in the vessel.FloatliterNo
fillVolumeAvailableCapacityFill Volume Available CapacityAvailable volume to be filled in the vessel.FloatliterNo
fluidLevelStatusBattery Water LevelThe status of the battery's water level. Will be OK or LOW.Enum-No

Pressure Vessel Health

Entity type: asset

Reading IDLabelDescriptionData TypeUnitIngestion Enabled
pressureVesselBatteryLevelPercentagePressure Vessel Battery Level PercentageBattery level percentage of the pressure vessel.IntegerpercentNo
pressureVesselPressurePressure Vessel PressurePressure of the pressure vessel.FloatkilopascalNo
pressureVesselTemperaturePressure Vessel TemperatureTemperature of the pressure vessel.FloatcelsiusNo

Pagination

All Readings API endpoints use cursor-based pagination. Each paginated response includes a pagination object:

{
    "pagination": {
        "endCursor": "dXNlcjpVMEc5V0ZYMnEw",
        "hasNextPage": true
    }
}
  • endCursor: Pass this value as the after query parameter in your next request to get the next page.
  • hasNextPage: If true, more data is available. Continue paginating until hasNextPage is false.